//+------------------------------------------------------------------+
//|                                                         CCI2.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                                   stb-78@mail.ru |
//+------------------------------------------------------------------+
  extern double TakeProfit = 1100;
  extern double ARRAY      = 96;
  extern int    TF         = 15;
  extern int    period_CCI = 96; 
  extern double Lot        = 1;    
  extern string SYMBOL     = "EURUSD";
  
  int LastTradeTime = 0;
  
  int start() 
  {  
     int Ticket, bar;
  double BID,
         ASK,
         SL=0,
         TP=0,
         CCI,
         max_CCI,
         min_CCI;                                  
    bool Ans         = false,
         Open_Bay_1  = false,
         Open_Sell_1 = false,
         Open_Bay_2  = false,
         Open_Sell_2 = false;

  //   
    RefreshRates();                                             
    BID = MarketInfo(SYMBOL,9);
    ASK = MarketInfo(SYMBOL,10);
    if (BID > iHigh (SYMBOL,PERIOD_D1,1))
      {
       for (bar=0; bar<ARRAY; bar++)
        {
         CCI = iCCI(SYMBOL,TF,period_CCI,PRICE_CLOSE,bar);
         if (CCI>max_CCI) max_CCI = CCI;
        }
       if (iCCI(SYMBOL,TF,period_CCI,PRICE_CLOSE,0)>=max_CCI) Open_Bay_1 = true;
       if (iCCI(SYMBOL,TF,period_CCI,PRICE_CLOSE,0)<max_CCI) Open_Sell_2 = true;
      }
    if (BID < iLow (SYMBOL,PERIOD_D1,1))
      {
       for (bar=0; bar<ARRAY; bar++)
        {
         CCI = iCCI(SYMBOL,TF,period_CCI,PRICE_CLOSE,bar);
         if (CCI<min_CCI) min_CCI = CCI;
        }
       if (iCCI(SYMBOL,TF,period_CCI,PRICE_CLOSE,0)<=min_CCI) Open_Sell_1 = true;
       if (iCCI(SYMBOL,TF,period_CCI,PRICE_CLOSE,0)>min_CCI) Open_Bay_2 = true;
      } 
        
  //   1
      if (Open_Bay_1 == true && OrdersTotal()==0 && TimeDay(TimeCurrent())!=LastTradeTime)                                           
        {      
         SL = iLow(SYMBOL,PERIOD_D1,0);
         TP = ASK + MathAbs(iLow(SYMBOL,PERIOD_D1,1)-iLow(SYMBOL,PERIOD_D1,0));
         Ticket=OrderSend(SYMBOL,OP_BUY,Lot,ASK,20,SL,TP);         
         LastTradeTime=TimeDay(TimeCurrent()); //   ,      
        }
     if (Open_Sell_1 == true && OrdersTotal()==0 && TimeDay(TimeCurrent())!=LastTradeTime)                                             
        {      
         SL = iHigh (SYMBOL,PERIOD_D1,0);
         TP = BID - MathAbs(iHigh(SYMBOL,PERIOD_D1,1)-iHigh(SYMBOL,PERIOD_D1,0));
         Ticket = OrderSend(SYMBOL,OP_SELL,Lot,BID,20,SL,TP);         
         LastTradeTime=TimeDay(TimeCurrent());  //   ,     
        }
        
  //   2
      if (Open_Bay_2 == true && OrdersTotal()==0 && TimeDay(TimeCurrent())!=LastTradeTime)                                           
        {      
         SL = BID - TakeProfit/2*Point; 
         TP = ASK + TakeProfit*Point;
         Ticket=OrderSend(SYMBOL,OP_BUY,Lot,ASK,20,SL,TP);         
         LastTradeTime=TimeDay(TimeCurrent()); 
        }
     if (Open_Sell_2 == true && OrdersTotal()==0 && TimeDay(TimeCurrent())!=LastTradeTime)                                             
        {      
         SL = BID + TakeProfit/2*Point;                                            
         TP = BID - TakeProfit*Point;
         Ticket = OrderSend(SYMBOL,OP_SELL,Lot,BID,20,SL,TP);         
         LastTradeTime=TimeDay(TimeCurrent());   
        } 
   //  
     for(int i=0; i<=OrdersTotal(); i++)   
      {  
       if (OrderSelect(i,SELECT_BY_POS)==true)  
         {                                        
          if (OrderSymbol() != SYMBOL) continue;
          if (OrderType()==0)
            {
             if (OrderProfit()>0 && TimeDay(TimeCurrent())!=LastTradeTime)
             Ans = OrderClose(OrderTicket(),OrderLots(),ASK,20);
            }
          if (OrderType()==1)
            {
            if (OrderProfit()>0 && TimeDay(TimeCurrent())!=LastTradeTime)
            Ans = OrderClose(OrderTicket(),OrderLots(),BID,20);
            }
         } 
      }        
   return;       
  }